Section Group.

Parameter G : Set.
Parameter op : G -> G -> G.
Parameter e : G.

Infix "o" := op (at level 35, right associativity).
Axiom assoc : forall a b c : G, a o (b o c) = (a o b) o c.
Axiom unit : forall a : G, a o e = a /\ e o a = a.
Axiom inv : forall a : G, exists b : G, b o a = e /\ a o b = e.

Lemma unit_l : forall a : G, e o a = a.
Proof.
intro.
apply (unit a).
Qed.

Lemma unit_r : forall a : G, a o e = a.
Proof.
intro.
apply (unit a).
Qed.

Lemma unique_inv :
  forall a b c : G, (a o b = e /\ b o a = e /\ a o c = e /\ 
    c o a = e) -> b = c.
Proof.
intros.
rewrite <- unit_l with b.
assert (c o a = e).
apply H.
rewrite <- H0.
rewrite <- assoc.
assert (a o b = e).
apply H.
rewrite H1.
rewrite unit_r.
reflexivity.
Qed.

End Group.
